%{!?python_sitelib: %define python_sitelib %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib()")}

%define PRELUDE_GROUP prelude
%define POLICYCOREUTILSVER 2.0.78-1
%define SELINUXTARGETEDVER 3.7.19-279

Name: prelude-correlator
Epoch:   1
Version: 3.0.0
Release: 1%{?dist}
Summary: Real time correlator of events received by Prelude Manager

Group: Applications/Internet
License: GPLv2+
URL: https://www.prelude-siem.org
Source0: %{name}-%{version}.tar.gz
Source1: prelude-correlator.init

Buildroot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildRequires: python-devel python-setuptools
Requires(pre)   : /usr/sbin/useradd
Requires(post)  : /sbin/chkconfig
Requires(preun) : /sbin/chkconfig
Requires(preun) : /sbin/service
Requires(postun): /sbin/service
Requires: libprelude-python >= 1:3.0
Requires: libprelude-python < 1:3.1
Requires: python-setuptools
Requires: python-netaddr
BuildArch: noarch


%define loadpolicy() \
. %{_sysconfdir}/selinux/config; \
( cd /usr/share/selinux/%1; semodule -n -b base.pp.bz2 -i %{name}.pp.bz2 -s %1 &> /dev/null ); \


%description
Prelude-Correlator allows conducting multi-stream correlations
thanks to a powerful programming language for writing correlation
rules. With any type of alert able to be correlated, event
analysis becomes simpler, quicker and more incisive. This
correlation alert then appears within the Prewikka interface
and indicates the potential target information via the set of
correlation rules.


%package selinux
Summary: SELinux policy for prelude-correlator
Group: System Environment/Base
BuildRequires: checkpolicy
BuildRequires: policycoreutils >= %{POLICYCOREUTILSVER}
BuildRequires: bzip2
Requires(pre): policycoreutils >= %{POLICYCOREUTILSVER}
Requires(pre): coreutils
Requires(pre): selinux-policy-targeted >= %{SELINUXTARGETEDVER}
Requires: selinux-policy-targeted >= %{SELINUXTARGETEDVER}
Requires: prelude-correlator = %{epoch}:%{version}-%{release}
Requires(post): policycoreutils >= %{POLICYCOREUTILSVER}
Requires(postun): policycoreutils >= %{POLICYCOREUTILSVER}


%description selinux
SELinux policy for prelude-correlator.

%prep
%setup -q

%build
cd $RPM_BUILD_DIR/%{name}-%{version}/selinux/
make


%install
rm -rf %{buildroot}
mkdir -p %{buildroot}/%{_datadir}/selinux/targeted/
install -p -m 644 $RPM_BUILD_DIR/%{name}-%{version}/selinux/%{name}.pp.bz2 \
    %{buildroot}/%{_datadir}/selinux/targeted/
%{__python} setup.py install -O1 --root=%{buildroot}
mkdir -p %{buildroot}%{_initrddir}
mkdir -p %{buildroot}/%{_var}/run/%{name}
install -m 755 %SOURCE1 %{buildroot}%{_initrddir}/%{name}


%clean
rm -rf %{buildroot}

%pre
getent passwd prelude-correlator >/dev/null || \
/usr/sbin/useradd -M -r -N -d / -s /sbin/nologin \
        -c "prelude-correlator" prelude-correlator > /dev/null 2>&1 || :
/usr/sbin/usermod -g %{PRELUDE_GROUP} prelude-correlator > /dev/null 2>&1 || :

%post
/sbin/chkconfig --add %{name}
if [ -s %{_var}/lib/%{name}/context.dat ]; then
 sed -i "s/PreludeCorrelator/preludecorrelator/g" %{_var}/lib/%{name}/context.dat
fi
/bin/chown -R %{name}:%{PRELUDE_GROUP} /etc/prelude-correlator/
/bin/chown -R %{name}:%{PRELUDE_GROUP} /var/lib/prelude-correlator/

%post selinux
if [ $1 -eq 1 ]; then
   %loadpolicy targeted prelude-correlator
   restorecon %{_sysconfdir}/%{name} || :
   restorecon %{_initrddir}/%{name} || :
   restorecon -R %{_sharedstatedir}/%{name} || :
else
   semodule -n -s targeted -r prelude-correlator 2>/dev/null
   %loadpolicy targeted prelude-correletor
fi


%preun
if [ $1 = 0 ]; then
 /sbin/service %{name} stop > /dev/null 2>&1 || :
 /sbin/chkconfig --del %{name}
fi


%postun
if [ "$1" -ge "1" ]; then
 /sbin/service %{name} condrestart >/dev/null 2>&1 || :
fi


%postun selinux
semodule -n -s targeted -r prelude-correlator 2>/dev/null || :
restorecon %{_sysconfdir}/%{name} || :
restorecon %{_initrddir}/%{name} || :
restorecon -R %{_sharedstatedir}/%{name} || :


%files
%defattr(-,root,root,-)
%doc AUTHORS COPYING NEWS HACKING.README
%attr(0660,prelude-correlator,prelude) %{_sysconfdir}/%{name}/*
%dir %attr(0770,prelude-correlator,prelude) %{_sysconfdir}/%{name}/
%dir %attr(0770,prelude-correlator,prelude) %{_sysconfdir}/%{name}/*
%dir %attr(0770,prelude-correlator,prelude) %{_sysconfdir}/%{name}/rules/python
%config(noreplace) %attr(0660,prelude-correlator,prelude) %{_sysconfdir}/%{name}/%{name}.conf
%{_initrddir}/%{name}
%{_bindir}/%{name}
%dir %attr(0775,prelude-correlator,prelude) %{_var}/lib/%{name}
%attr(0770,prelude-correlator,prelude) %{_var}/lib/%{name}/*
%dir %attr(0775,prelude-correlator,prelude) %{_var}/run/%{name}
%{python_sitelib}/preludecorrelator/
%{python_sitelib}/prelude_correlator*.egg-info
%{_sysconfdir}/%{name}/conf.d/README


%files selinux
%{_datadir}/selinux/targeted/%{name}.pp.bz2


%changelog
* Thu Apr 21 2016 Antoine Luong <antoine.luong@c-s.fr> - 3.0.0-1
- New upstream release

* Fri Apr 15 2016 Antoine Luong <antoine.luong@c-s.fr> - 3.0.0rc4-1
- New upstream release

* Fri Apr 08 2016 Antoine Luong <antoine.luong@c-s.fr> - 1.3.0rc3-1
- New upstream release

* Fri Apr 01 2016 Antoine Luong <antoine.luong@c-s.fr> - 1.3.0rc2-1
- New upstream release

* Fri Mar 25 2016 Antoine Luong <antoine.luong@c-s.fr> - 1.3.0rc1-1
- New upstream release

* Fri Mar 18 2016 Song Tran <song.tran@c-s.fr> - 1.3.0beta2-1
- New upstream release
- Mask the messages of usermod command
- Force libprelude version between 1.3 and 1.4
- Change permissions with 'chown' command for /etc/prelude-correlator/
- Change permissions from root to prelude-correlator user
- Fix pidfile to start prelude-correlator with dedicated user

* Fri Feb 26 2016 Song Tran <song.tran@c-s.fr> - 1.3.0beta1-1
- New upstream release
- Use a dedicated prelude-correlator user

* Tue Jan 12 2016 Antoine Luong <antoine.luong@c-s.fr> - 1.3.0alpha1-1
- New upstream release

* Mon Jan 04 2016 Song Tran <song.tran@c-s.fr> - 1.2.6-2
- Add conf.d folder
- Integrate SELinux policy

* Wed Jul 22 2015 Antoine Luong <antoine.luong@c-s.fr> - 1.2.6-1
- New upstream release

* Mon Oct 27 2014 Antoine Luong <antoine.luong@c-s.fr> - 1.2.6rc4-1
- New upstream release

* Mon Sep 22 2014 Antoine Luong <antoine.luong@c-s.fr> - 1.2.6rc2-1
- Renamed PreludeCorrelator to preludecorrelator

* Tue Sep 16 2014 Song Tran <song.tran@c-s.fr> - 1.2.6rc1-1
- New upstream release

* Mon Jul 21 2014 Antoine Luong <antoine.luong@c-s.fr> - 1.2.5-2
- Added a short sleep in init script before restoring SELinux

* Thu Aug 10 2012 Antoine Luong <antoine.luong@c-s.fr> - 1.0.1-2
- Added missing dependency to python-setuptools
- Fixed #517 : Prelude Correlator not starting (SELinux)

* Wed Jun 15 2011 Vincent Quéméner <vincent.quemener@c-s.fr> - 1.0.0-4
- Rebuilt for RHEL6

* Wed Feb 09 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1:1.0.0-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Wed Jul 21 2010 David Malcolm <dmalcolm@redhat.com> - 1:1.0.0-2
- Rebuilt for https://fedoraproject.org/wiki/Features/Python_2.7/MassRebuild

* Sun May 02 2010 Steve Grubb <sgrubb@redhat.com> - 1.0.0-1
- New upstream release

* Tue Mar 09 2010 Steve Grubb <sgrubb@redhat.com> - 1.0.0rc4-1
- New upstream release

* Mon Feb 01 2010 Steve Grubb <sgrubb@redhat.com> - 1.0.0rc2-1
- New upstream release

* Tue Nov 03 2009 Steve Grubb <sgrubb@redhat.com> - 0.9.0-0.10.beta8
- New beta release

* Sun Jul 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.9.0-0.9.beta6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Fri Jul 10 2009 Steve Grubb <sgrubb@redhat.com> 0.9.0-0.8.beta6
- New beta release

* Mon Mar 02 2009 Steve Grubb <sgrubb@redhat.com> 0.9.0-0.7.beta3
- Fix bz#484361 Error message regarding missing arguments lua ruleset

* Thu Feb 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.9.0-0.6.beta3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Sat Dec 05 2008 Steve Grubb <sgrubb@redhat.com> 0.9.0-0.5.beta3
- Fix bz#469824 Correct brute force correlation rules
- Add signal header to prelude-correlator.c so it builds correctly bz 474698
- Include unowned /usr/include/prelude-correlator directory

*Fri Jul 11 2008 Steve Grubb <sgrubb@redhat.com> 0.9.0-0.3.beta3
- New beta release

*Thu Jul 03 2008 Steve Grubb <sgrubb@redhat.com> 0.9.0-0.1.beta2
- Initial packaging

